//----------------------------------------------------------
//This Source Code Form is subject to the terms of the
//Mozilla Public License, v.2.0. If a copy of the MPL
//was not distributed with this file, You can obtain one
//at http://mozilla.org/MPL/2.0/.
//----------------------------------------------------------

//////////////////////////////////////////////////////////////////
//
// Объект-помощник для чтения файла фич
//
//////////////////////////////////////////////////////////////////

Перем ЧтениеТекста;
Перем КоллекцияСтрок;
Перем ПозицияВКоллекции;

////////////////////////////////////////////////////////////////////
//{ Программный интерфейс

Процедура Инициализировать(Знач ПутьФайла, Знач Кодировка = "UTF-8") Экспорт
    КоллекцияСтрок = Новый Массив;
    ПозицияВКоллекции = -1;
    
    ЧтениеТекста = Новый ЧтениеТекста(ПутьФайла, Кодировка);
    ПрочитатьТекстВКоллекцию();
КонецПроцедуры

Процедура ИнициализироватьИзСтроки(Знач Строка) Экспорт
    КоллекцияСтрок = Новый Массив;
    ПозицияВКоллекции = -1;
    
    ЧтениеТекста = Неопределено;
    ПрочитатьСтрокуВКоллекцию(Строка);
КонецПроцедуры

Процедура Закрыть() Экспорт
    Если ЧтениеТекста <> Неопределено Тогда
        ЧтениеТекста.Закрыть();
    КонецЕсли;
КонецПроцедуры

Функция ПрочитатьСтроку() Экспорт
    ПозицияВКоллекции  = ПозицияВКоллекции  + 1;
    Если ПозицияВКоллекции >= КоллекцияСтрок.Количество() Тогда
        Возврат Неопределено;
    КонецЕсли;

    ОчереднаяСтрока = КоллекцияСтрок[ПозицияВКоллекции];
    Возврат ОчереднаяСтрока;
КонецФункции // ОчереднаяСтрока()

Процедура ВернутьсяНаСтрокуНазад() Экспорт
    ПозицияВКоллекции  = ПозицияВКоллекции  - 1;
КонецПроцедуры

//}

Процедура ПрочитатьТекстВКоллекцию()
    Пока Истина Цикл
        ОчереднаяСтрока = ЧтениеТекста.ПрочитатьСтроку();
        Если ОчереднаяСтрока = Неопределено Тогда
            Прервать;
        КонецЕсли;
        КоллекцияСтрок.Добавить(ОчереднаяСтрока);
    КонецЦикла;

КонецПроцедуры

Процедура ПрочитатьСтрокуВКоллекцию(Знач Строка)
    Для Счетчик=1 По СтрЧислоСтрок(Строка) Цикл
        ОчереднаяСтрока = СтрПолучитьСтроку(Строка, Счетчик);
        КоллекцияСтрок.Добавить(ОчереднаяСтрока);
    КонецЦикла;

КонецПроцедуры