Перем ИсполнительБДД;
Перем ВозможныеСтатусыВыполнения;
Перем ТипыСостоянияJUnit;

Процедура Сформировать(Знач РезультатыВыполнения, Знач СтатусВыполнения, Знач ПутьОтчетаJUnit) Экспорт
    // ДатаНачала = Неопределено;
    ИсполнительБДД = Новый ИсполнительБДД;
    ВозможныеСтатусыВыполнения = ИсполнительБДД.ВозможныеСтатусыВыполнения();
    
    ЧитательГеркин = Новый ЧитательГеркин;
    ВозможныеТипыШагов = ЧитательГеркин.ВозможныеТипыШагов();
    
    ТипШага_Функциональность = ВозможныеТипыШагов.Функциональность; 
    МассивШагов = Новый Массив;
    МассивШагов.Добавить(ТипШага_Функциональность);
    МассивШагов.Добавить(ВозможныеТипыШагов.Сценарий);
    СтруктураИтогов = ИсполнительБДД.ПолучитьИтоговыеРезультатыВыполнения(РезультатыВыполнения, МассивШагов);
    
    ЗаписьXML = Новый ЗаписьXML;
    ЗаписьXML.УстановитьСтроку("UTF-8");
    ЗаписьXML.ЗаписатьОбъявлениеXML();
    
    КоличествоОшибок = СтруктураИтогов[ТипШага_Функциональность][ВозможныеСтатусыВыполнения.Сломался];
    КоличествоНереализованныхТестов = СтруктураИтогов[ТипШага_Функциональность][ВозможныеСтатусыВыполнения.НеРеализован];
    ВсегоТестов = СтруктураИтогов[ТипШага_Функциональность][ВозможныеСтатусыВыполнения.Пройден] + КоличествоОшибок + КоличествоНереализованныхТестов;
    
    // // ВремяВыполнения = ТекущаяДата() - ДатаНачала;
    ВремяВыполнения = 0;//TODO вычислять время выполнения прогона фич, шагов и сценариев
    
    ЗаписьXML.ЗаписатьНачалоЭлемента("testsuites");
    ЗаписьXML.ЗаписатьАтрибут("name", XMLСтрока("1bdd"));
    ЗаписьXML.ЗаписатьАтрибут("time", XMLСтрока(ВремяВыполнения));
    ЗаписьXML.ЗаписатьАтрибут("tests", XMLСтрока(ВсегоТестов));
    ЗаписьXML.ЗаписатьАтрибут("failures", XMLСтрока(КоличествоОшибок));
    ЗаписьXML.ЗаписатьАтрибут("skipped", XMLСтрока(КоличествоНереализованныхТестов)); // или disabled
    
    Для каждого Узел Из РезультатыВыполнения.Строки Цикл
        ЗаписьXML.ЗаписатьНачалоЭлемента("testsuite");	
        
        ЗаписьXML.ЗаписатьАтрибут("name", Узел.Тело);
        
        ЗаписьXML.ЗаписатьНачалоЭлемента("properties");//TODO нужен ли пустой блок properties	
        ЗаписьXML.ЗаписатьКонецЭлемента();
        
        Для Каждого УзелСценария Из Узел.Строки Цикл
            Если УзелСценария.ТипШага = ВозможныеТипыШагов.Сценарий Тогда
                Для Каждого УзелШага Из УзелСценария.Строки Цикл
                    Если УзелШага.ТипШага = ВозможныеТипыШагов.Шаг Тогда
                        ЗаполнитьРезультатТестовогоСлучая(ЗаписьXML, УзелСценария, УзелШага);
                        Если УзелШага.СтатусВыполнения <> ВозможныеСтатусыВыполнения.Пройден Тогда
                            Прервать;
                        КонецЕсли;
                    КонецЕсли;
                КонецЦикла;	
            КонецЕсли;
        КонецЦикла;	
        
        ЗаписьXML.ЗаписатьКонецЭлемента();
    КонецЦикла;
    
    ЗаписьXML.ЗаписатьКонецЭлемента();
    
    СтрокаХМЛ = ЗаписьXML.Закрыть();
    
    ФайлОтчета = Новый Файл(ОбъединитьПути(ТекущийКаталог(), ПутьОтчетаJUnit));
    
    ЗаписьXML = Новый ЗаписьXML;
    ЗаписьXML.ОткрытьФайл(ФайлОтчета.ПолноеИмя);
    ЗаписьXML.ЗаписатьБезОбработки(СтрокаХМЛ);// таким образом файл будет записан всего один раз, и не будет проблем с обработкой на билд-сервере TeamCity
    ЗаписьXML.Закрыть();
    Сообщить(" ");
    Сообщить("Путь к лог-файлу проверки в формате Ant.JUnit <"+ФайлОтчета.ПолноеИмя+">");
    
КонецПроцедуры

Процедура ЗаполнитьРезультатТестовогоСлучая(ЗаписьXML, Знач УзелСценария, Знач УзелШага)
    
    ЗаписьXML.ЗаписатьНачалоЭлемента("testcase");
    ЗаписьXML.ЗаписатьАтрибут("classname", УзелСценария.Тело);//TODO решить, какое выбрать classname для сценария
    ЗаписьXML.ЗаписатьАтрибут("name", УзелШага.Тело);
    
    ТипСостоянияJUnit = ПолучитьТипыСостоянияJUnit()[УзелШага.СтатусВыполнения];
    ЗаписьXML.ЗаписатьАтрибут("status", ТипСостоянияJUnit);
    
    Если УзелШага.СтатусВыполнения = ВозможныеСтатусыВыполнения.Сломался Тогда
        ЗаписьXML.ЗаписатьНачалоЭлемента(ТипСостоянияJUnit);
        ОписаниеОшибкиВыполнения = УзелШага.ОписаниеОшибкиВыполнения;
        Сообщить("ОписаниеОшибкиВыполнения "+ОписаниеОшибкиВыполнения);
        // TODO: НайтиНедопустимыеСимволыXML()
        XMLОписаниеОшибкиВыполнения = XMLСтрока(ОписаниеОшибкиВыполнения); 
        ЗаписьXML.ЗаписатьАтрибут("message", XMLОписаниеОшибкиВыполнения);
        ЗаписьXML.ЗаписатьКонецЭлемента();
    КонецЕсли;
    
    ЗаписьXML.ЗаписатьКонецЭлемента();
    
КонецПроцедуры

Функция ПолучитьТипыСостоянияJUnit()
    Если ТипыСостоянияJUnit = Неопределено Тогда
        
        ТипыСостоянияJUnit = Новый Соответствие;
        ТипыСостоянияJUnit.Вставить(ВозможныеСтатусыВыполнения.Пройден, "passed");
        ТипыСостоянияJUnit.Вставить(ВозможныеСтатусыВыполнения.Сломался, "failure");
        ТипыСостоянияJUnit.Вставить(ВозможныеСтатусыВыполнения.НеРеализован, "skipped");
        ТипыСостоянияJUnit = Новый ФиксированноеСоответствие(ТипыСостоянияJUnit);
    КонецЕсли;
    Возврат ТипыСостоянияJUnit;
КонецФункции // ПолучитьТипыСостоянияJUnit()